package de.schatenseite.android.waldemar;

import android.appwidget.AppWidgetManager;
import android.content.Intent;
import android.os.Bundle;
import android.preference.EditTextPreference;
import android.preference.ListPreference;
import android.preference.Preference;
import android.preference.PreferenceActivity;
import android.preference.PreferenceManager;
import de.schatenseite.android.datepreference.DatePreference;

public class WaldemarPreferences extends PreferenceActivity {
	int widgetId;
	public void enableDisablePreferences(String val) {
		EditTextPreference pref_name = (EditTextPreference)findPreference("pref_name");
		ListPreference pref_mode = (ListPreference)findPreference("pref_mode");
		EditTextPreference pref_duration = (EditTextPreference)findPreference("pref_duration");
		DatePreference pref_dateStart = (DatePreference)findPreference("pref_dateStart");
		DatePreference pref_dateThen = (DatePreference)findPreference("pref_dateThen");

		pref_name.setSummary(pref_name.getText());
		
		int index = pref_mode.findIndexOfValue(val);
		if (index == 0) {
			pref_mode.setSummary(R.string.mode1);
			pref_duration.setEnabled(false);
			pref_duration.setSummary(R.string.duration_summary);
			pref_dateStart.setEnabled(false);
			pref_dateStart.setSummary(R.string.dateStart_summary);
			pref_dateThen.setEnabled(true);
			pref_dateThen.setSummary(pref_dateThen.getSummaryString());
		} else if (index == 1) {
			pref_mode.setSummary(R.string.mode2);
			pref_duration.setEnabled(false);
			pref_duration.setSummary(R.string.duration_summary);
			pref_dateStart.setEnabled(true);
			pref_dateStart.setSummary(pref_dateStart.getSummaryString());
			pref_dateThen.setEnabled(true);
			pref_dateThen.setSummary(pref_dateThen.getSummaryString());
		} else if (index == 2) {
			pref_mode.setSummary(R.string.mode3);
			pref_duration.setEnabled(true);
			pref_duration.setSummary(pref_duration.getText()+" "+getApplicationContext().getString(R.string.days));
			pref_dateStart.setEnabled(false);
			pref_dateStart.setSummary(R.string.dateStart_summary);
			pref_dateThen.setEnabled(true);
			pref_dateThen.setSummary(pref_dateThen.getSummaryString());
		} else if (index == 3) {
			pref_mode.setSummary(R.string.mode4);
			pref_duration.setEnabled(true);
			pref_duration.setSummary(pref_duration.getText()+" "+getApplicationContext().getString(R.string.days));
			pref_dateStart.setEnabled(true);
			pref_dateStart.setSummary(pref_dateStart.getSummaryString());
			pref_dateThen.setEnabled(false);
			pref_dateThen.setSummary(R.string.dateThen_summary);
		}
	}
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        PreferenceManager.setDefaultValues(this, R.xml.preferences, false);
        addPreferencesFromResource(R.xml.preferences);

        Intent intent=getIntent();
        Bundle extras=intent.getExtras();
        if (extras != null) {
            widgetId=extras.getInt(AppWidgetManager.EXTRA_APPWIDGET_ID, AppWidgetManager.INVALID_APPWIDGET_ID);
        }

        final EditTextPreference pref_name = (EditTextPreference)findPreference("pref_name");
        final ListPreference pref_mode = (ListPreference)findPreference("pref_mode");

        String val = pref_mode.getValue();
		enableDisablePreferences(val);

        pref_name.setOnPreferenceChangeListener(new Preference.OnPreferenceChangeListener() {
        	public boolean onPreferenceChange(Preference preference, Object newValue) {
        		pref_name.setSummary((CharSequence)newValue);
        		return true;
        	}
        });
        pref_mode.setOnPreferenceChangeListener(new Preference.OnPreferenceChangeListener() {
        	public boolean onPreferenceChange(Preference preference, Object newValue) {
        		final String val = newValue.toString();
        		enableDisablePreferences(val);
        		return true;
        	}
        });
    }

    @Override
    public void onBackPressed() {
        // this is the intent broadcast/returned to the widget
        Intent updateIntent = new Intent(this, WaldemarWidget.class);
        updateIntent.setAction("PreferencesUpdated");
        updateIntent.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, widgetId);
        setResult(RESULT_OK, updateIntent);
        sendBroadcast(updateIntent);
        finish();
    }
}